searchNodes=[{"ref":"Gelfx.html","title":"Gelfx","type":"module","doc":"A logger backend for Elixir applications using Logger and Graylog based on GELF (Graylog extended logging format). Usage Add Gelfx to your application by adding {:gelfx, &quot;~&gt; 0.2.2&quot;} to your list of dependencies in mix.exs: def deps do [ # ... {:gelfx, &quot;~&gt; 0.2.2&quot;} ] end And adding it to your :logger configuration in config.exs: config :logger, backends: [ :console, Gelfx ] Since GELF relies on json to encode the payload Gelfx will need a JSON library. By default Gelfx will use Jason which needs to be added to your deps in mix.exs: {:jason, &quot;~&gt; 1.0&quot;} Options Besides :level, :format and :metadata, which are advised by Logger Gelfx supports: :host - hostname of the server running the GELF endpoint, defaults to localhost :port - port on which the graylog server runs the respective GELF input, defaults to 12201 :protocol - either :tcp or :udp, :http is not jet supported, defaults to :udp :connection_timeout - sets the timeout in ms after which the :tcp connect timeouts, defaults to 5s. :compression - either :gzip or :zlib can be set and will be used for package compression when UDP is used as protocol :format - defaults to &quot;$message&quot; :hostname - used as source field in the GELF message, defaults to the hostname returned by :inet.gethostname() :json_library - json library to use, has to implement a encode/1 which returns a {:ok, json} tuple in case of success :utc_log - this option should not be configured directly. But rather by setting the :utc_log option in the Logger config. Should the Logger config change after the Gelfx backend is initialized the option has to be reconfigured. Message Format The GELF message format version implemented by this library is 1.1, the docs can be found here. Messages can include a short_message and a full_message, Gelfx will use the first line of each log message for the short_message and will place the whole message in the full_message field. Metadata will be included in the message using the additional field syntax. The Keys of the metadata entries have to match ^\\_?[\\w\\.\\-]*$, keys missing an leading underscore are automatically prepended with one. Key collisions are NOT prevented by Gelfx, additionally the keys id and _id are automatically omitted due to the GELF specification. Levels Graylog relies on the syslog definitions for logging levels. Gelfx maps the Elixir levels as follows: ElixirSysylogGELF - Selector Emergency0 Alert1 Critical2 :errorError3 :warnWarning4 Notice5 :infoInformational6 :debugDebug7"},{"ref":"Gelfx.html#encode/2","title":"Gelfx.encode/2","type":"function","doc":"Encodes the given LogEntry using the configured json library"},{"ref":"Gelfx.html#init/2","title":"Gelfx.init/2","type":"function","doc":""},{"ref":"Gelfx.html#spawn_conn/1","title":"Gelfx.spawn_conn/1","type":"function","doc":"Spawns a :gen_udp / :gen_tcp connection based on the configuration"},{"ref":"Gelfx.html#spawn_conn/4","title":"Gelfx.spawn_conn/4","type":"function","doc":""},{"ref":"Gelfx.html#submit/2","title":"Gelfx.submit/2","type":"function","doc":"Sends the given payload over the connection. In case an TCP connection is used the 0x00 delimiter required by gelf is added. Should the used connection use UDP the payload is compressed using the configured compression, in case the given payload exceeds the chunk threshold it is chunked."},{"ref":"Gelfx.html#submit/3","title":"Gelfx.submit/3","type":"function","doc":""}]